// Code generated by cdpgen. DO NOT EDIT.

// Package accessibility implements the Accessibility domain.
package accessibility

import (
	"context"

	"github.com/mafredri/cdp/protocol/internal"
	"github.com/mafredri/cdp/rpcc"
)

// domainClient is a client for the Accessibility domain.
type domainClient struct{ conn *rpcc.Conn }

// NewClient returns a client for the Accessibility domain with the connection set to conn.
func NewClient(conn *rpcc.Conn) *domainClient {
	return &domainClient{conn: conn}
}

// Disable invokes the Accessibility method. Disables the accessibility
// domain.
func (d *domainClient) Disable(ctx context.Context) (err error) {
	err = rpcc.Invoke(ctx, "Accessibility.disable", nil, nil, d.conn)
	if err != nil {
		err = &internal.OpError{Domain: "Accessibility", Op: "Disable", Err: err}
	}
	return
}

// Enable invokes the Accessibility method. Enables the accessibility domain
// which causes `AXNodeId`s to remain consistent between method calls. This
// turns on accessibility for the page, which can impact performance until
// accessibility is disabled.
func (d *domainClient) Enable(ctx context.Context) (err error) {
	err = rpcc.Invoke(ctx, "Accessibility.enable", nil, nil, d.conn)
	if err != nil {
		err = &internal.OpError{Domain: "Accessibility", Op: "Enable", Err: err}
	}
	return
}

// GetPartialAXTree invokes the Accessibility method. Fetches the
// accessibility node and partial accessibility tree for this DOM node, if it
// exists.
func (d *domainClient) GetPartialAXTree(ctx context.Context, args *GetPartialAXTreeArgs) (reply *GetPartialAXTreeReply, err error) {
	reply = new(GetPartialAXTreeReply)
	if args != nil {
		err = rpcc.Invoke(ctx, "Accessibility.getPartialAXTree", args, reply, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "Accessibility.getPartialAXTree", nil, reply, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "Accessibility", Op: "GetPartialAXTree", Err: err}
	}
	return
}

// GetFullAXTree invokes the Accessibility method. Fetches the entire
// accessibility tree for the root Document
func (d *domainClient) GetFullAXTree(ctx context.Context, args *GetFullAXTreeArgs) (reply *GetFullAXTreeReply, err error) {
	reply = new(GetFullAXTreeReply)
	if args != nil {
		err = rpcc.Invoke(ctx, "Accessibility.getFullAXTree", args, reply, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "Accessibility.getFullAXTree", nil, reply, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "Accessibility", Op: "GetFullAXTree", Err: err}
	}
	return
}

// GetChildAXNodes invokes the Accessibility method. Fetches a particular
// accessibility node by AXNodeId. Requires `enable()` to have been called
// previously.
func (d *domainClient) GetChildAXNodes(ctx context.Context, args *GetChildAXNodesArgs) (reply *GetChildAXNodesReply, err error) {
	reply = new(GetChildAXNodesReply)
	if args != nil {
		err = rpcc.Invoke(ctx, "Accessibility.getChildAXNodes", args, reply, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "Accessibility.getChildAXNodes", nil, reply, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "Accessibility", Op: "GetChildAXNodes", Err: err}
	}
	return
}

// QueryAXTree invokes the Accessibility method. Query a DOM node's
// accessibility subtree for accessible name and role. This command computes
// the name and role for all nodes in the subtree, including those that are
// ignored for accessibility, and returns those that mactch the specified name
// and role. If no DOM node is specified, or the DOM node does not exist, the
// command returns an error. If neither `accessibleName` or `role` is
// specified, it returns all the accessibility nodes in the subtree.
func (d *domainClient) QueryAXTree(ctx context.Context, args *QueryAXTreeArgs) (reply *QueryAXTreeReply, err error) {
	reply = new(QueryAXTreeReply)
	if args != nil {
		err = rpcc.Invoke(ctx, "Accessibility.queryAXTree", args, reply, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "Accessibility.queryAXTree", nil, reply, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "Accessibility", Op: "QueryAXTree", Err: err}
	}
	return
}
