// Code generated by cdpgen. DO NOT EDIT.

package storage

// Type Enum of possible storage types.
type Type string

// Type as enums.
const (
	TypeNotSet         Type = ""
	TypeAppcache       Type = "appcache"
	TypeCookies        Type = "cookies"
	TypeFileSystems    Type = "file_systems"
	TypeIndexeddb      Type = "indexeddb"
	TypeLocalStorage   Type = "local_storage"
	TypeShaderCache    Type = "shader_cache"
	TypeWebsql         Type = "websql"
	TypeServiceWorkers Type = "service_workers"
	TypeCacheStorage   Type = "cache_storage"
	TypeAll            Type = "all"
	TypeOther          Type = "other"
)

func (e Type) Valid() bool {
	switch e {
	case "appcache", "cookies", "file_systems", "indexeddb", "local_storage", "shader_cache", "websql", "service_workers", "cache_storage", "all", "other":
		return true
	default:
		return false
	}
}

func (e Type) String() string {
	return string(e)
}

// UsageForType Usage for a storage type.
type UsageForType struct {
	StorageType Type    `json:"storageType"` // Name of storage type.
	Usage       float64 `json:"usage"`       // Storage usage (bytes).
}

// TrustTokens Pair of issuer origin and number of available (signed, but not
// used) Trust Tokens from that issuer.
//
// Note: This type is experimental.
type TrustTokens struct {
	IssuerOrigin string  `json:"issuerOrigin"` // No description.
	Count        float64 `json:"count"`        // No description.
}
